{% extends 'historical_data_2.html' %}

{% block title %}{% endblock %}

<!-- Specific Page CSS goes HERE  -->
{% block stylesheets %}
    {{ super() }} {# referring to content in parent templates #}
{% endblock %}

{% block more_content %}

  <div class="container-fluid">
    <div class="row">
      <div class="col-8">
        <!-- table from historical_data_2 template -->
        <div class="container-fluid">
          <table class="table table-bordered table-striped table-responsive mb-0 table-wrapper-scroll-y my-custom-scrollbar tableFixHead table-hover">
            <thead>
              <tr>
                {% for item in column_names %}
                <th scope="col">{{item[0]}}</th>
                {% endfor %}
              </tr>
            </thead>
            <tbody>
              {% for row in data %}
              <!-- this part only works if row[1] is name of sensor -->
                <tr data-href="/add_diagramm/{{row[1]}}">
                  {% for item in row %}
                    <td>{{item}}</td>
                  {% endfor %}
                </tr>
              {% endfor %}
            </tbody>
          </table>
        </div>
      </div>

      <!-- When item in table is clicked, data chart will be displayed on the
           right side -->
      <div class="col-4">
        {% for item in diagramms_dict %}
        <div class="row my-padded">
          <a class="btn btn-close" type="button" aria-lable="Close" href="/remove_diagramm/{{item}}"></a>
          <!-- <button type="button" class="btn-close" aria-label="Close" href="/remove_diagramm/{{item}}"></button> -->
          {{diagramms_dict[item]["description"]}}
          <!-- {{item}} -->
        </div>
        <div class="row my-padded justify-content-end">
          <div class="dropdown">
            <button class="btn btn-primary dropdown-toggle" type="button" id="dropdownMenuButton1" data-bs-toggle="dropdown" aria-expanded="false">
              Prozessschritt {{diagramms_dict[item]["process_step_id"]}}
            </button>
            <ul class="dropdown-menu" aria-labelledby="dropdownMenuButton1">
              {% for id in process_step_id_list %}
              <li><a class="dropdown-item" href="/change_process_step/{{item}}/id={{id}}">Prozessschritt {{id}}</a></li>
              {% else %}
              <li><a class="dropdown-item" href="/change_process_step/{{item}}/id={{process_step_id_list}}">Prozessschritt {{id}}</a></li>
              {% endfor %}
            </ul>
          </div>
        </div>
        <div class="row my-padded-diagramm">
          <canvas id="myChart_{{item}}" width="400" height="400">
            <p>Seems like your canvas is not working...</p>
          </canvas>
        </div>
        {% endfor %}
      </div>
    </div>


{% endblock %}


{% block javascripts %}
{{ super() }}

<!-- Chart.js built files -->
<script
src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/3.9.1/chart.min.js"
integrity="sha512-ElRFoEQdI5Ht6kZvyzXhYG9NqjtkmlkfYk0wr6wHxU9JEHakS7UJZNeml5ALk+8IKlU6jDgMabC3vkumRokgJA=="
crossorigin="anonymous"
referrerpolicy="no-referrer"
></script>

<!-- script for creating all charts on this page by looping over them -->
<script>
  /**
   * Time calculation for days, hours, minutes and seconds
   * These calculations are performed on the timestamp for the display
   * of the data in the charts.
   * Same as in index20.html
   */
  function milliseconds_to_time(milliseconds) {
      var days = Math.floor(milliseconds / (1000 * 60 * 60 * 24));
      var hours = Math.floor((milliseconds % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
      var minutes = Math.floor((milliseconds % (1000 * 60 * 60)) / (1000 * 60));
      var seconds = Math.floor((milliseconds % (1000 * 60)) / 1000);
      if (minutes < 10){
          minutes = "0" + minutes
      }
      if (seconds < 10){
          seconds = "0" + seconds
      }
      return hours + ":" + minutes + ":" + seconds;
  };

  /**
   * Create charts with specific configurations
   */
  function mySaviourChart(ctx, yLabelString, labels, data) {
    let config = {
      type: 'line',
      data: {
        labels: labels,
        datasets: [{
          label: "Random Dataset",
          backgroundColor: "rgba(215, 227, 244, 0)",
          borderColor: window.theme.primary,
          data: data,
          fill: true,
        }],
      },
      options: {
        elements: {
          point:{
            radius: 0
          }
        },
        spanGaps: true,
        responsive: true,
        plugins: {
          legend: {
            display: false
          }
        },
        tooltips: {
          mode: 'null',
        },
        hover: {
          mode: 'null',
        },
        scales: {
          x: {
            display: true,
            title: {
              display: true,
              align: 'end',
              padding: 2,
              text: 'Zeit'
            },
            ticks: {
                maxTicksLimit: 6,
                maxRotation: 45,
            }
          },
          y: {
            display: true,
            title: {
              display: true,
              align: "end",
              padding: 2,
              text: yLabelString
            }
          },
        }
      }
    };
    let lineChart = new Chart(ctx, config);
    return lineChart;
  };

  // get chart data
  let chart_data = JSON.parse({{ chart_data | tojson }});
  let chartData = JSON.parse(chart_data);
  let sensor_ids = JSON.parse({{ sensor_ids | tojson }});
  let sensorIds = JSON.parse(sensor_ids);
  // get array with all the charts, that should be displayed
  let canvases = Array.from(document.getElementsByTagName("canvas"));
  // create empty list to collect charts
  let lineCharts = [];
  // loop over all charts to configure and create them
  canvases.forEach((canvas, index) => {
    let ctx = canvas.getContext("2d");
    // determine yLabel for this chart, here it is the unit
    let yLabelString = sensorIds[index].unit;
    // determine sensor id for this chart
    // Charts are sorted, thus index of diagramm and index
    // of sensor id is the same
    let dataSensor = sensorIds[index].id;
    // from chartData extract data for each chart
    // store labels (dataTime) and values (dataValue) separately
    let dataTime = [];
    let dataValue = [];
    chartData.forEach(datapoint => {
      if (datapoint.sensor_id === dataSensor) {
      dataTime.push(milliseconds_to_time(datapoint.timestamp));
      dataValue.push(datapoint.value);
      };
      return dataTime, dataValue;
    });
    // create Chart using function from above
    let lineChart = mySaviourChart(ctx, yLabelString, dataTime, dataValue);
    // put created chart in list of line charts
    lineCharts.push(lineChart);
  });

</script>

{% endblock %}
